from meta import util

"""
Options - Unvisited: 
    1. Enter Manor
    2. Smell the Roses.
    3. Talk to Friend
    4. Leave

Options - Visited: 
    1. Inspect the ashes of the manor
    3. Talk to ghost
    3. Leave

Areas Adjacent:
    Town Center

Monsters:
    Rat

People:
    Mentor
    Friend
    Ghost

Requirements:
    Received Fish

Exit condition:
        self.flag_mentor_dead = True
"""


# Naming convention is ScenarioYourArea
class ScenarioMentorsManor(object):
    def __init__(self, nav, player):
        self.PC = player
        self.nav = nav
        self.name = "Mentor's Manor"
        self.initial_description = """
A giant manor, well maintained over the years.        
        """
        self.flag_mentor_dead = False
        self.flag_visited = False
        self.exiting = False
        self.exit_condition = False

    def mentor_dead(self):
        print("Your Mentor lies on the floor in his own bed")
        self.flag_mentor_dead = True

    def investigate_warehouse(self):
        # todo add pre-requisite
        print("""You walk up the stairs to the door. You find the door is open a crack. You slowly open \n
        the door and enter the manor""")
 # Add story

    def leave(self):
        print("You escape the flaming manor, still in shock of what has transpired inside its walls")
        self.exiting = True

    def start(self):
        if self.flag_visited:
            self.visited()
        else:
            self.unvisited()

    def unvisited(self):
        # Option list to print out
        options = ["Enter the Manor", "Stop and smell the roses", "Talk to your childhood friend"]
        # Function list to execute when menu option is selected
        exec = [self.retreive_fish, self.investigate_warehouse]
        ev = util.EventHandler()
        print(self.initial_description)
        ev.wait_for_user()
        util.clear()
        while not self.exiting:
            # Do this if both flags are True
            if self.flag_retreive_fish and self.flag_beat_rat:
                if not self.exit_condition:
                    options.append("Leave")
                    exec.append(self.leave)
                self.exit_condition = True
            util.menu_generator(options, exec)
        self.nav.travel()

    def visited(self):
        pass